
# 如何练习ACM模式输入输出模式 | 如何准备笔试 | 卡码网

卡码网地址：[https://kamacoder.com](https://kamacoder.com)

## 为什么卡码网

录友们在求职的时候会发现，很多公司的笔试题和面试题都是ACM模式， 而大家习惯去力扣刷题，力扣是核心代码模式。

当大家在做ACM模式的算法题的时候，需要自己处理数据的输入输出，**如果没有接触过的话，还是挺难的**。

[知识星球](https://programmercarl.com/other/kstar.html)里很多录友的日常打卡中，都表示被 ACM模式折磨过：

<div align="center"><img src='https://file1.kamacoder.com/i/algo/20230727163624.png' width=500 alt=''></img></div>

<div align="center"><img src='https://file1.kamacoder.com/i/algo/20230727163938.png' width=500 alt=''></img></div>

<div align="center"><img src='https://file1.kamacoder.com/i/algo/20230727164042.png' width=500 alt=''></img></div>

<div align="center"><img src='https://file1.kamacoder.com/i/algo/20230727164151.png' width=500 alt=''></img></div>

<div align="center"><img src='https://file1.kamacoder.com/i/algo/20230727164459.png' width=500 alt=''></img></div>

所以我正式推出：**卡码网**（[https://kamacoder.com](https://kamacoder.com)），**专门帮助大家练习ACM模式**。

那么之前大家去哪里练习ACM模式呢？

去牛客做笔试真题，结果发现 ACM模式没练出来，题目倒是巨难，一点思路都没有，代码更没有写，ACM模式无从练起。

去洛谷，POJ上练习？ 结果发现 题目超多，不知道从哪里开始刷，也没有一个循序渐进的刷题顺序。

**而卡码网上有我精选+制作的25道题目**！我还把25题的后台测试数据制作了一遍，保证大家练习的效果。

为什么题目不多，只有25道？

因为大家练习ACM模式不需要那么多题目，有一个循序渐进的练习过程就好了。

这25道题目包含了数组、链表、哈希表、字符串、二叉树、动态规划以及图的的题目，常见的输入输出方式都覆盖了。

**这是最精华的25道题目**！。

## 卡码网长什么样

来看看这极简的界面，没有烂七八糟的功能，只有刷题！

<div align="center"><img src='https://file1.kamacoder.com/i/algo/20230727171535.png' width=500 alt=''></img></div>

在「状态」这里可以看到 大家提交的代码和判题记录，目前卡码网（[https://kamacoder.com](https://kamacoder.com)）几乎无时无刻都有卡友在提交代码。
看看大家周六晚上都在做什么，刷哪些题目。

<div align="center"><img src='https://file1.kamacoder.com/i/algo/20230730200451.png' width=500 alt=''></img></div>


提交代码的界面是这样的，**目前支持所有主流刷题语言**。

<div align="center"><img src='https://file1.kamacoder.com/i/algo/20230727172727.png' width=500 alt=''></img></div>

## 题解

基本大家来卡码网（[https://kamacoder.com](https://kamacoder.com)）练习ACM模式，都是对输入输出不够了解的，所以想看现成的题解，看看究竟是怎么处理的。

所以我用C++把卡码网上25道题目的题解都写了，并发布到Github上：

[https://github.com/youngyangyang04/kamacoder-solutions](https://github.com/youngyangyang04/kamacoder-solutions)

<div align="center"><img src='https://file1.kamacoder.com/i/algo/20230730200709.png' width=500 alt=''></img></div>

**欢迎去Github上star，欢迎fork，也欢迎来Github仓库贡献其他语言版本，成为contributor**。

如果不懂如何和开源项目提交代码，[可以看这里](https://www.programmercarl.com/qita/join.html)

目前已经有两位录友贡献C和Java版本了。

<div align="center"><img src='https://file1.kamacoder.com/i/algo/20230730195613.png' width=500 alt=''></img></div>

期待在Github（https://github.com/youngyangyang04/kamacoder-solutions） 的contributors上也出现你的头像。

目前题解只有C++代码吗？

当然不是，大多数题目已经有了 Java、python、C版本。 **其他语言版本，就给录友们成为contributor的机会了**。

## 最后

卡码网地址：[https://kamacoder.com](https://kamacoder.com)

快去体验吧，笔试之前最好 把卡码网25道题目都刷完。

期待录友们成为最早一批把卡码网刷爆的coder！

